.586
.MODEL FLAT, STDCALL
OPTION CASEMAP:NONE

INCLUDE windows.inc
INCLUDE kernel32.inc
INCLUDE msvcrt.inc
INCLUDE masm32.inc
INCLUDE D:\masm32\macros\macros.asm

INCLUDELIB kernel32.lib
INCLUDELIB msvcrt.lib
INCLUDELIB masm32.lib


WldMatchB				PROTO	:DWORD,:DWORD ; this is the form to be used

WldMatchC				PROTO	:DWORD,:DWORD ; this is here only as placeholder
;some other function should be tested instead

;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
.DATA
	ALIGN 16
	Str_Target_1	\	; 20 characters on each line
	BYTE	"The time has come th"		;  0
	BYTE	"e walrus said to spe"		; 20
	BYTE	"ak of many things,",13,10	; 40
	BYTE	" of birds and bugs a"		; 60
	BYTE	"nd ceiling wax, of c"		; 80
	BYTE	"abbages and kings.",13,10 	;100
	BYTE	"And if the sea is bo"		;120
	BYTE	"iling hot and whethe"		;140
	BYTE	"r pigs have wings "		;160
	BYTE	" ",0				;180
	
	;full strings, no * or ?
	Str_Patt_1_01	BYTE	"The time has come",0
	Str_Patt_1_02	BYTE	"he time has come",0
	Str_Patt_1_03	BYTE	"come",0
	Str_Patt_1_04	BYTE	"boiling hot and whether",0
	Str_Patt_1_05	BYTE	"ve wings  ",0
	Str_Patt_1_06	BYTE	"some other string",0
	; * 
	Str_Patt_1_07	BYTE	"*The",0
	Str_Patt_1_08	BYTE	"*The*",0
	Str_Patt_1_09	BYTE	"*******The",0
	Str_Patt_1_10	BYTE	"*The*******",0
	Str_Patt_1_11	BYTE	"*The*******",0
	Str_Patt_1_12	BYTE	"*********The*boiling*",0
	Str_Patt_1_13	BYTE	"*******The time",0
	Str_Patt_1_14	BYTE	"*The****pigs***",0
	Str_Patt_1_15	BYTE	"*The*pigs",0
	Str_Patt_1_16	BYTE	"*",0
	Str_Patt_1_17	BYTE	"****",0
	Str_Patt_1_18	BYTE	"*The***",0
	Str_Patt_1_19	BYTE	"*The*birds**",0
	Str_Patt_1_20	BYTE	"*The*pigs**",0
	Str_Patt_1_21	BYTE	"*The*things,",13,10,0
	Str_Patt_1_22	BYTE	" The*things,",13,10,0
	Str_Patt_1_23	BYTE	"*The pigs",0
	Str_Patt_1_24	BYTE	"*The*******string",0
	
	; ?
	Str_Patt_1_25	BYTE	"The?time?has?come?",0
	Str_Patt_1_26	BYTE	"?The?t?me?ha??c????",0
	Str_Patt_1_27	BYTE	"The?ti me?has? co?e?",0
	Str_Patt_1_28	BYTE	"?he? time?has?come?",0
	Str_Patt_1_29	BYTE	"??The?time?has?come? ",0
	Str_Patt_1_30	BYTE	"??",0
	Str_Patt_1_31	BYTE	"?he?sea is?",0
	Str_Patt_1_32	BYTE	"?h",0
	Str_Patt_1_33	BYTE	"t?",0
	Str_Patt_1_34	BYTE	"?t?",0
	Str_Patt_1_35	BYTE	"?he ",0
	Str_Patt_1_36	BYTE	"? ",0
	Str_Patt_1_37	BYTE	"?ot?",0
	Str_Patt_1_38	\
	BYTE	"The time has come th"		;  0
	BYTE	"e walrus said to spe"		; 20
	BYTE	"ak of many things,",13,10	; 40
	BYTE	" of birds and bugs a"		; 60
	BYTE	"nd ce??ing wax, of c"		; 80
	BYTE	"abbages and kings.",13,10 	;100
	BYTE	"And if?the sea is bo"		;120
	BYTE	"iling hot and whethe"		;140
	BYTE	"r pigs have wings?"		;160
	BYTE	"?",0				;180
	
	; both "?" and "*"
	Str_Patt_1_39	\
	BYTE	"*nd ce??ing wax, of c"		
	BYTE	"abbages and kings.",13,10
	BYTE	"And if?the sea is bo"
	BYTE	"iling hot and **",0
	
	
	
	Str_Target_2	BYTE	"A*BC"
	Str_Patt_2_01	BYTE	"A*C",0
	
	
	
	
	;
	;					 String to scan        Pattern to use	 Correct 
	;															  value
	NrOfTests	EQU		40
	TestTable	DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_01,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_02,	1
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_03,	13
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_04,	138
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_05,	169
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_06,	-1
				
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_07,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_08,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_09,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_10,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_11,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_12,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_13,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_14,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_15,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_16,	180
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_17,	180
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_18,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_19,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_20,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_21,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_22,	-1
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_23,	-1
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_24,	-1
				
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_25,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_26,	-1
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_27,	-1
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_28,	-1
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_29,	-1
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_30,	179
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_31,	127
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_32,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_33,	4
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_34,	3
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_35,	0
				
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_36,	-1
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_37,	146
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_38,	0
				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_39,	80
;				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_40,	0
;				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_41,	0
;				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_42,	0
;				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_43,	0
;				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_44,	0
;				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_45,	0
;				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_46,	0
;				DWORD	OFFSET Str_Target_1, OFFSET Str_Patt_1_47,	0
				
				
				DWORD	OFFSET Str_Target_2, OFFSET Str_Patt_2_01,	0
				
				
				
				
	Counter1	DWORD		0		
	CounterOK	DWORD		0
	CounterFail	DWORD		0


ITER    EQU     1000              ; number of iterations
OVERHEAD EQU    30              ; 15 for PPlain, 17 for PMMX

	
ALIGN   4
COUNTER DD      0               ; loop counter
TICS    DD      0               ; temporary storage of clock

RESULTLIST  DD  ITER DUP (0)    ; list of test results
				
				
				
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
.CODE
App_Entry_Point:
	
	print	"=========================================",13,10
	print	" Test",9,"Return",9,"Correct",9,"Status",9,"    Time",13,10
	print	" "    ,9," val"  ,9,"  val",13,10
	print	"=========================================",13,10
	
	push	esi
	push	ebx
	mov		esi,		OFFSET TestTable
	mov		Counter1,	0
	
	.WHILE	Counter1<NrOfTests
		add		Counter1,	1
		print	" "
		print	sstr$(Counter1),9,"  "
		; first function to test
		
		INVOKE	WldMatchC,	dword ptr [esi], dword ptr [esi+4]
		
		MOV     [COUNTER],0
		MOV		[RESULTLIST],0
		TESTLOOP1:
        XOR		eax,	eax
        CPUID
        RDTSC                   ; read clock counter
        MOV     [TICS],EAX      ; save count
        XOR		eax,	eax
        CPUID
        CLD                     ; non-pairable filler
		REPT    8
		        NOP                     ; eight NOP's to avoid shadowing effect
		ENDM
		;============================
		INVOKE	WldMatchC,	dword ptr [esi], dword ptr [esi+4]
		mov		ebx,		eax
		;============================
        CLC                     ; non-pairable filler with shadow

        RDTSC                   ; read counter again
        SUB     EAX,[TICS]      ; compute difference
        SUB     EAX,OVERHEAD    ; subtract clocks used by fillers etc.
        MOV     EDX,[COUNTER]   ; loop counter
        add     [RESULTLIST],EAX   ; store result in table
        ADD     EDX,TYPE RESULTLIST     ; increment counter
        MOV     [COUNTER],EDX           ; store counter
        CMP     EDX,ITER * (TYPE RESULTLIST)
        JB      TESTLOOP1                ; repeat ITER times		
		
		print	sstr$(ebx),9,"  "
		print	sstr$(dword ptr [esi+8]),9
		.IF		ebx==dword ptr [esi+8]
			print	"  OK",9,"    "
			add		CounterOK,	1
		.ELSE
			print	"!!Fail!!",9,"    "
			add		CounterFail,1
		.ENDIF
		xor		edx,		edx
		mov		eax,		[RESULTLIST]
;		mov		ecx,		ITER
;		div		ecx
		print	sstr$(eax)
		print	" ",13,10,9,"  "
		
		
		; second function to test
		INVOKE	WldMatchB,	dword ptr [esi], dword ptr [esi+4]
		
		MOV     [COUNTER],0
		MOV		[RESULTLIST],0
		TESTLOOP2:
        XOR		eax,	eax
        CPUID
        RDTSC                   ; read clock counter
        MOV     [TICS],EAX      ; save count
        XOR		eax,	eax
        CPUID
        CLD                     ; non-pairable filler
		REPT    8
		        NOP                     ; eight NOP's to avoid shadowing effect
		ENDM
		;============================
		
		INVOKE	WldMatchB,	dword ptr [esi], dword ptr [esi+4]
		mov		ebx,		eax
		;============================
        CLC                     ; non-pairable filler with shadow

        RDTSC                   ; read counter again
        SUB     EAX,[TICS]      ; compute difference
        SUB     EAX,OVERHEAD    ; subtract clocks used by fillers etc.
        MOV     EDX,[COUNTER]   ; loop counter
        add     [RESULTLIST],EAX   ; store result in table
        ADD     EDX,TYPE RESULTLIST     ; increment counter
        MOV     [COUNTER],EDX           ; store counter
        CMP     EDX,ITER * (TYPE RESULTLIST)
        JB      TESTLOOP2                ; repeat ITER times		
		
		print	sstr$(ebx),9,"  "
		print	sstr$(dword ptr [esi+8]),9
		.IF		ebx==dword ptr [esi+8]
			print	"  OK",9,"    "
			add		CounterOK,	1
		.ELSE
			print	"!!Fail!!",9,"    "
			add		CounterFail,1
		.ENDIF
		
		XOR		EDX,		EDX
		mov		eax,		[RESULTLIST]
;		mov		ecx,		ITER
;		div		ecx
		print	sstr$(eax)
		print	" ",13,10,13,10
		
		
		
		add		esi,		12
	.ENDW
	print	"=========================================",13,10
	print	"Summary:",13,10
	print	"   Number of succesfull tests:   "
	print	sstr$(CounterOK),13,10
	print	"   Number of fails:              "
	print	sstr$(CounterFail),13,10
	print	"=========================================",13,10,13,10
	
	pop		ebx
	pop		esi
	inkey
	INVOKE	ExitProcess,	NULL
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
WldMatchC_Local	STRUCT
	PRZ_ESI			DWORD	?
	PRZ_EDI			DWORD	?
	PRZ_EBX			DWORD	?
	PRZ_EBP			DWORD	?
WldMatchC_Local	ENDS
WldMatchC_Param	STRUCT
	ptrString		DWORD	?
	ptrPattern		DWORD	?
WldMatchC_Param	ENDS
WldMatchC_STACK	STRUCT
	Locals			WldMatchC_Local	<>
	RetAddress		DWORD			?
	Parameters		WldMatchC_Param	<>
WldMatchC_STACK ENDS

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
ALIGN 16
WldMatchC		PROC	pString:DWORD,pPattern:DWORD
	
	sub		esp,		SIZEOF WldMatchC_Local
	mov		(WldMatchC_STACK ptr [esp]).Locals.PRZ_ESI,esi
	mov		(WldMatchC_STACK ptr [esp]).Locals.PRZ_EDI,edi
	mov		(WldMatchC_STACK ptr [esp]).Locals.PRZ_EBX,ebx
	mov		(WldMatchC_STACK ptr [esp]).Locals.PRZ_EBP,ebp
	mov		edi,		(WldMatchC_STACK ptr [esp]).Parameters.ptrPattern
	mov		esi,		(WldMatchC_STACK ptr [esp]).Parameters.ptrString
	sub		edi,		1
	xor		eax,		eax
	xor		ebx,		ebx
	xor		ecx,		ecx
	cmp		byte ptr [edi+1], 0
	jne		LeadingPatt
	cmp		byte ptr [esi], 0
	je		PatternEnd
	jmp		ReturnFalse
	
ALIGN 16
LeadingPatt:
	add		edi,	1
	mov		al,		byte ptr [edi]
	test	eax,	eax
	jz		PatternEnd
	cmp		eax,	"*"
	je		LeadingPatt
	cmp		eax,	"?"
	jne		LoopScanString_Cond
	cmp		byte ptr [esi],0
	je		ReturnFalse
	add		esi,	1
	add		ebx,	1
	jmp		LeadingPatt
	
ALIGN 16
LoopScanString_Entry:
	mov		al,		byte ptr [esi]
	cmp		al,		byte ptr [edi]
	jne		NextChar
	mov		edx,	edi
	mov		ebp,	esi
	test	ecx,	ecx
	jnz		ScanPattern_Cond
	mov		ecx,	ebp
	jmp		ScanPattern_Cond
	
	ALIGN 16
		ScanPattern_Entry:
			cmp		al,		"?"
			je		ScanPattern_Next
			cmp		al,		byte ptr [esi]
			je		ScanPattern_Next
			mov		esi,	ebp
			mov		edi,	edx
			cmp		ecx,	ebp
			jne		NextChar
			xor		ecx,	ecx
			jmp		NextChar
		ScanPattern_Next:
			add		edi,	1
			add		esi,	1
			mov		al,		byte ptr [edi]
			cmp		al,		"*"
			jne		ScanPattern_Cond
			
			LeadingPatt2:
				add		edi,		1
				mov		al,			byte ptr [edi]
				test	eax,		eax
				jz		PatternEnd
				cmp		eax,		"*"
				je		LeadingPatt2
				cmp		eax,		"?"
				jne		LoopScanString_Cond
				cmp		byte ptr [esi], 0
				je		ReturnFalse
				add		esi,		1
				jmp		LeadingPatt2
			
		ScanPattern_Cond:
			test	eax,	eax
			jz		PatternEnd
			cmp		byte ptr [esi],0
			jne		ScanPattern_Entry
			mov		eax,	-1
			jmp		Return
		NextChar:
			add		esi,	1
		LoopScanString_Cond:
			cmp		byte ptr [esi],0
			jne		LoopScanString_Entry
ReturnFalse:
	mov		eax,	-1
	jmp		Return
	
PatternEnd:
	mov		eax,	ecx
	test	ecx,	ecx
	jz		Return
	sub		eax,	ebx
	sub		eax,	(WldMatchC_STACK ptr [esp]).Parameters.ptrString
Return:
	mov		esi,(WldMatchC_STACK ptr [esp]).Locals.PRZ_ESI
	mov		edi,(WldMatchC_STACK ptr [esp]).Locals.PRZ_EDI
	mov		ebx,(WldMatchC_STACK ptr [esp]).Locals.PRZ_EBX
	mov		ebp,(WldMatchC_STACK ptr [esp]).Locals.PRZ_EBP
	add		esp,		(SIZEOF WldMatchC_Local)
	ret		(SIZEOF WldMatchC_Param)
WldMatchC 		ENDP


WldMatchB_Local	STRUCT
	PRZ_ESI			DWORD	?
	PRZ_EDI			DWORD	?
	PRZ_EBX			DWORD	?
	PRZ_EBP			DWORD	?
WldMatchB_Local	ENDS
WldMatchB_Param	STRUCT
	ptrString		DWORD	?
	ptrPattern		DWORD	?
WldMatchB_Param	ENDS
WldMatchB_STACK	STRUCT
	Locals			WldMatchB_Local	<>
	RetAddress		DWORD			?
	Parameters		WldMatchB_Param	<>
WldMatchB_STACK ENDS

WldMatchB		PROC	pString:DWORD,pPattern:DWORD
	
	sub		esp,		SIZEOF WldMatchB_Local
	mov		(WldMatchB_STACK ptr [esp]).Locals.PRZ_ESI,esi
	mov		(WldMatchB_STACK ptr [esp]).Locals.PRZ_EDI,edi
	mov		(WldMatchB_STACK ptr [esp]).Locals.PRZ_EBX,ebx
	mov		(WldMatchB_STACK ptr [esp]).Locals.PRZ_EBP,ebp
	mov		edi,		(WldMatchB_STACK ptr [esp]).Parameters.ptrPattern
	mov		esi,		(WldMatchB_STACK ptr [esp]).Parameters.ptrString
	sub		edi,		1
	xor		eax,		eax
	xor		ebx,		ebx
	xor		ecx,		ecx
	cmp		byte ptr [edi+1], 0
	jne		RemoveLead
	cmp		byte ptr [esi], 0
	je		PatternFound
	jmp		ReturnNotFound
	
ALIGN 16
RemoveLead:
	add		edi,	1
	mov		al,		byte ptr [edi]
	test	eax,	eax
	jz		PatternFound
	cmp		eax,	"*"
	je		RemoveLead
	cmp		eax,	"?"
	jne		ScanTarget_Cond
	cmp		byte ptr [esi],0
	je		ReturnNotFound
	add		esi,	1
	add		ebx,	1
	jmp		RemoveLead
	
	
	
	
ALIGN 16
ScanTarget_Entry:
	mov		al,		byte ptr [esi]
	cmp		al,		byte ptr [edi]
	jne		NextChar
	mov		edx,	edi
	mov		ebp,	esi
	test	ecx,	ecx
	jnz		ScanPattern_Cond
	mov		ecx,	ebp
	jmp		ScanPattern_Cond
	
	ALIGN 16
		ScanPattern_Entry:
			cmp		al,		"?"
			je		ScanPattern_Next
			cmp		al,		byte ptr [esi]
			je		ScanPattern_Next
			mov		esi,	ebp
			mov		edi,	edx
			cmp		ecx,	ebp
			jne		NextChar
			xor		ecx,	ecx
			jmp		NextChar
		ScanPattern_Next:
			add		edi,	1
			add		esi,	1
			mov		al,		byte ptr [edi]
			cmp		al,		"*"
			jne		ScanPattern_Cond
			
			RemoveLead2:
				add		edi,		1
				mov		al,			byte ptr [edi]
				test	eax,		eax
				jz		PatternFound
				cmp		eax,		"*"
				je		RemoveLead2
				cmp		eax,		"?"
				jne		ScanTarget_Cond
				cmp		byte ptr [esi], 0
				je		ReturnNotFound
				add		esi,		1
				jmp		RemoveLead2
			
		ScanPattern_Cond:
			test	eax,	eax
			jz		PatternFound
			cmp		byte ptr [esi],0
			jne		ScanPattern_Entry
					mov		eax,	-1
					mov		esi,(WldMatchB_STACK ptr [esp]).Locals.PRZ_ESI
					mov		edi,(WldMatchB_STACK ptr [esp]).Locals.PRZ_EDI
					mov		ebx,(WldMatchB_STACK ptr [esp]).Locals.PRZ_EBX
					mov		ebp,(WldMatchB_STACK ptr [esp]).Locals.PRZ_EBP
					add		esp,		(SIZEOF WldMatchB_Local)
					ret		(SIZEOF WldMatchB_Param)
		NextChar:
			add		esi,	1
		ScanTarget_Cond:
			cmp		byte ptr [esi],0
			jne		ScanTarget_Entry


ReturnNotFound:
	mov		eax,	-1
	mov		esi,(WldMatchB_STACK ptr [esp]).Locals.PRZ_ESI
	mov		edi,(WldMatchB_STACK ptr [esp]).Locals.PRZ_EDI
	mov		ebx,(WldMatchB_STACK ptr [esp]).Locals.PRZ_EBX
	mov		ebp,(WldMatchB_STACK ptr [esp]).Locals.PRZ_EBP
	add		esp,		(SIZEOF WldMatchB_Local)
	ret		(SIZEOF WldMatchB_Param)
	
PatternFound:
	mov		eax,	ecx
	test	ecx,	ecx
	jz		Return
	sub		eax,	ebx
	sub		eax,	(WldMatchB_STACK ptr [esp]).Parameters.ptrString
Return:
	mov		esi,(WldMatchB_STACK ptr [esp]).Locals.PRZ_ESI
	mov		edi,(WldMatchB_STACK ptr [esp]).Locals.PRZ_EDI
	mov		ebx,(WldMatchB_STACK ptr [esp]).Locals.PRZ_EBX
	mov		ebp,(WldMatchB_STACK ptr [esp]).Locals.PRZ_EBP
	add		esp,		(SIZEOF WldMatchB_Local)
	ret		(SIZEOF WldMatchB_Param)
WldMatchB 		ENDP

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef
END App_Entry_Point